import pygame, os
from pygame.locals import *
from gameSprite import *
from gameObject import gameObject

class character(gameSprite):
    
    def __init__(self, gameWindow, left, top, speed, file_name):
    
        super(character, self).__init__(gameWindow, left, top, speed, file_name)
        
        self.movable = True
        
        self.moving_down_animation = 0
        self.moving_up_animation = 0
        self.moving_left_animation = 0
        self.moving_right_animation = 0
        
        self.attack_animation = 0
        self.death_animation = 0
        
        self.attacking = False
        self.dead = False
        
        self.type = "character"
               
        
    def move(self):        
        
        if self.attacking and self.attack_animation:
            
            self.set_sprite(self.attack_animation.get_current_frame())
            
        elif self.dead and self.death_animation:
            
            prev_frame_index = self.death_animation.current_frame
            current_frame = self.death_animation.get_current_frame()
            current_frame_index = self.death_animation.current_frame
            
            #Remove the object if the death animation ended 
            if(prev_frame_index > current_frame_index):
                self.do_remove = True
            else:
                self.set_sprite(current_frame)
            
        
        #elif (self.speed_x != 0 or self.speed_y != 0) and self.moving_animation:
            
        #    self.set_sprite(self.moving_animation.get_current_frame())
        elif self.speed_x > 0 and self.moving_right_animation:
            self.set_sprite(self.moving_right_animation.get_current_frame())
        elif self.speed_x < 0 and self.moving_left_animation:
            self.set_sprite(self.moving_left_animation.get_current_frame())
        elif self.speed_y > 0 and self.moving_down_animation:
            self.set_sprite(self.moving_down_animation.get_current_frame())
        elif self.speed_y < 0 and self.moving_up_animation:
            self.set_sprite(self.moving_up_animation.get_current_frame())
            
        else:
            self.set_sprite(self.idle_sprite)
        
        super(character, self).move()
         
        