import pygame, os, time
from pygame.locals import * 
from gameSprite import gameSprite
from obstacle import obstacle
from enemy import *

class level:
    
    def __init__(self, level_num, gameScreen):
        
        self.gameScreen = gameScreen
        
        self.obstacles = []
        self.profiles = []
        self.enemies = []
        
        self.crystal_positions = []
        self.text_list = []
        
        self.wave_size = 0
        self.wave_last_upate = 0
        self.wave_frequency = 0
        self.time_limit = 0
        self.time_level_ends = 0
        self.crystals_to_protect = 0
        
        self.level_num = level_num
        
        
        background_image_file = "background-grass.png"
        red_crystal = "red_crystal.png"
        
        self.profile_pig = enemyProfile(gameScreen, "Pigs", "piggie_happy.png", "piggie_rage2.png")
        self.profile_bunny = enemyProfile(gameScreen, "Bunnies", "bunny_happy1.png", "bunny_angry2.png")
        self.profile_llama = enemyProfile(gameScreen, "Llamas", "llama_happy1.png", "llama_angry2.png")
        self.profile_cow = enemyProfile(gameScreen, "Cows", "cow_happy1.png", "cow_angry2.png")
        
        self.profiles.append(self.profile_pig)
        self.profiles.append(self.profile_bunny)
        self.profiles.append(self.profile_llama)
        self.profiles.append(self.profile_cow)
    
             
        if level_num == 1:
            
            self.wave_size = 3
            self.wave_frequency = 6
            self.time_limit = 30
            self.crystals_to_protect = 1
            
            self.text_list.append("Slicing Dicing Critter Killer 3000")
            self.text_list.append("Pax has been working hard to create a sustainable Energy Source on the family farm.\n\nOne night, working hard in his basement lab, Pax formulates a crystal form; Buraxolis.A single crystal can generate enough energy to keep an entire small country (about the size Comoros) powered for 5 years.\n\nThe unfortunate side effect is that it turns the farm animals into evil geniuses & they up and go beserk! Bonkers!  Whackadoo!\n\nPax must keep the world safe from these crazed creatures.\n\nThe solution?! Pax builds the Slicing Dicing Critter Killer 3000!\n\nNow go out there and make tartar out of those varmints!")
            self.text_list.append("How To Play\n\nProtect the Buraxolis Crystals by killing critters with the SDCK3000.\n\nKilling more of a specific type of animal causes those animals to gain RAGE.\n\nOnce at 100% RAGE you become their NEMESIS and those critters become stronger and faster!")
            self.text_list.append("Controls\n\nMove: Arrow Keys\nActivate SDCK3000: Space")     
            
            self.obstacles.append(obstacle(gameScreen, 600, 300,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 500, 300,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 400, 300,red_crystal))      

            
        if level_num == 2:
            
            self.wave_size = 5
            self.wave_frequency = 5
            self.time_limit = 30
            self.crystals_to_protect = 2
            
            self.obstacles.append(obstacle(gameScreen, 500, 300,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 400, 400,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 600, 400,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 500, 500,red_crystal))
            
        if level_num == 3:
            
            self.wave_size = 5
            self.wave_frequency = 5
            self.time_limit = 30
            self.crystals_to_protect = 2
            
            self.obstacles.append(obstacle(gameScreen, 300, 400,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 400, 400,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 500, 400,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 600, 400,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 700, 400,red_crystal))
            
        if level_num == 4:
             
            self.wave_size = 7
            self.wave_frequency = 5
            self.time_limit = 30
            self.crystals_to_protect = 3
            
            self.obstacles.append(obstacle(gameScreen, 300, 250,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 800, 250,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 500, 350,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 600, 350,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 500, 450,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 600, 450,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 300, 550,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 800, 550,red_crystal))
            
        if level_num == 5:
             
            self.wave_size = 7
            self.wave_frequency = 5
            self.time_limit = 30
            self.crystals_to_protect = 3
            
            self.obstacles.append(obstacle(gameScreen, 300, 250,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 700, 250,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 300, 350,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 400, 350,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 500, 350,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 600, 350,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 700, 350,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 300, 450,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 700, 450,red_crystal))
            
        if level_num == 6:
             
            self.wave_size = 7
            self.wave_frequency = 5
            self.time_limit = 30
            self.crystals_to_protect = 3
            
            self.obstacles.append(obstacle(gameScreen, 200, 250,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 200, 350,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 400, 350,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 400, 350,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 400, 450,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 600, 450,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 600, 550,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 800, 350,red_crystal))
            
        if level_num == 7:
             
            self.wave_size = 8
            self.wave_frequency = 5
            self.time_limit = 30
            self.crystals_to_protect = 4
            
            self.obstacles.append(obstacle(gameScreen, 200, 250,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 300, 250,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 700, 250,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 800, 250,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 200, 350,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 300, 350,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 700, 350,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 800, 350,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 200, 550,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 300, 550,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 700, 550,red_crystal))
            self.obstacles.append(obstacle(gameScreen, 800, 550,red_crystal))
        
        background_image_file = os.path.join("data", background_image_file)
        self.background_image = pygame.image.load(background_image_file).convert()
        
    def add_enemy(self, enemy, enemy_list):
        
        #Add enemies to the screen, but not on top of one another
        is_bad_pos = True
        pos = (0, 0)
        
        while(is_bad_pos):
            
            is_bad_pos = False
            
            pos = enemy.get_random_start_pos()
            temp_starting_rect = pygame.Rect(pos[0], pos[1], enemy.width, enemy.height)
            
            for obj in self.enemies:
                if(obj.rect.colliderect(temp_starting_rect)):
                    is_bad_pos = True
             
        enemy.set_pos(pos[0], pos[1])
                    
        enemy_list.append(enemy)
        
    def update(self, game_objects):
        
        now = time.time()
        
        if(now - self.wave_last_upate > self.wave_frequency):
            
            new_enemies = []
            
            for i in xrange(0, self.wave_size):         
                #Generate random number to determine the type of enemy
                #0 = pig, 1 = bunny, 2 = llama, 3 = cow
                enemy_type = int(random.random() * 4)
                
                if(enemy_type == 0):
                    self.add_enemy(pig(self.gameScreen, self.profile_pig, self.obstacles), new_enemies)
                elif(enemy_type == 1):
                    self.add_enemy(bunny(self.gameScreen, self.profile_bunny, self.obstacles), new_enemies)
                elif(enemy_type == 2):
                    self.add_enemy(llama(self.gameScreen, self.profile_llama, self.obstacles), new_enemies)
                elif(enemy_type == 3):
                    self.add_enemy(cow(self.gameScreen, self.profile_cow, self.obstacles), new_enemies)
                
            self.enemies.extend(new_enemies)
            game_objects.extend(new_enemies)
            self.wave_last_upate = now
            
    def start(self):
        
        self.time_level_ends = time.time() + self.time_limit
            

            
    def draw_background(self, level_surface):
        
        level_surface.blit(self.background_image, (0, 0))
            
    
        