import pygame, os
from pygame.locals import *
from gameSprite import gameSprite

class obstacle(gameSprite):
    
    def __init__(self, gameWindow, left, top, file_name):
    
        super(obstacle, self).__init__(gameWindow, left, top, 0, file_name)
        
        self.type = "obstacle"
        self.movable = False
        
        self.weight = 100
        
        self.hitpoints = 100
        
        pygame.mixer.init()
        self.obstacle_channel = pygame.mixer.Channel(3)
        
        file_name = os.path.join("data", "gem_eaten.wav")
        self.gem_eaten_sound = pygame.mixer.Sound(file_name)
        
        file_name = os.path.join("data", "gem_hit.wav")
        self.gem_hit_sound = pygame.mixer.Sound(file_name)
        
        
        
        
    def take_damage(self, amount):
        
        self.hitpoints -= amount

        self.obstacle_channel.play(self.gem_hit_sound)
        
        if(self.hitpoints <= 0):
            self.do_remove = True
            self.obstacle_channel.play(self.gem_eaten_sound)
            
    
    def draw(self):
        
        super(obstacle, self).draw()
        
        #Draw text to indicate number of hitpoints left
        font = pygame.font.Font(None, 20)
        text = font.render(str(self.hitpoints), 1, (0, 0, 0))
        text_rect = text.get_rect()
        
        text_left = self.left + (self.width / 2) - (text_rect.width / 2)
        text_top = self.top + self.height - text_rect.height
        
        hitpoints_rect = pygame.Rect(text_left, text_top, text_rect.width, text_rect.height)
        
        self.gameWindow.screen.blit(text, hitpoints_rect)
        