import pygame, os, sys
from pygame.locals import *
from character import *
from gameSprite import *

class player(character):
    
    def __init__(self, gameWindow, left, top, speed, file_name):
        
        super(player, self).__init__(gameWindow, left, top, speed, file_name)
        
        self.type = "player"
        
        player_attack_animation = ["sawblade.png","sawblade_1.png"]
        self.attack_animation = animation(player_attack_animation, .01)
        
        pygame.mixer.init()
        file_name = os.path.join("data", "saw1.wav")
        self.saw_sound = pygame.mixer.Sound(file_name)
        self.saw_channel = pygame.mixer.Channel(1)
        
        self.starting_lives = 2
        
        self.lives = self.starting_lives
        
        self.weight = 20
        
    def reset(self):
        
        self.lives = self.starting_lives
        
    def did_collide(self, obj):
        
        if(self.attacking and obj.type == "enemy" and pygame.sprite.spritecollide(self, [obj], False, pygame.sprite.collide_mask)):
            if(obj.dead == False):
                obj.kill()
        
        super(player, self).did_collide(obj)
        
    def cleanup(self):
        self.saw_channel.stop()
        
    def update(self):
        
        #Fix for collision detection bug: Player might get pushed beyond the invisible horizon barrier
        if(self.top < 250):
            self.top = 251
        
    def update_controls(self):
   
        for event in pygame.event.get(): 
            
            if event.type == QUIT: 
                sys.exit(0) 
            
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_LEFT:
                    self.speed_x -= self.speed
                    #self.speed_x =  self.speed * -1
                if event.key == pygame.K_RIGHT:
                    self.speed_x += self.speed
                    #self.speed_x = self.speed
                if event.key == pygame.K_UP:
                    self.speed_y -= self.speed
                    #self.speed_y = self.speed * -1
                if event.key == pygame.K_DOWN:
                    self.speed_y += self.speed
                    #self.speed_y = self.speed
                
                if event.key == pygame.K_SPACE:
                    self.attacking = True
                    self.saw_channel.play(self.saw_sound, -1)
                    
            if event.type == pygame.KEYUP:
                if event.key == pygame.K_LEFT:
                    self.speed_x += self.speed
                if event.key == pygame.K_RIGHT:
                    self.speed_x -= self.speed
                if event.key == pygame.K_UP:
                    self.speed_y += self.speed
                if event.key == pygame.K_DOWN:
                    self.speed_y -= self.speed
                    
                if event.key == pygame.K_SPACE:
                    self.attacking = False
                    self.saw_channel.stop()
                    
                if event.key == pygame.K_ESCAPE:
                    self.state = "quit"
                if event.key == pygame.K_F1:
                    print "trying to win"
                    self.state = "win"
                    
                    
            
        
                    
                    
